> For the complete documentation index, see [llms.txt](https://docs.orai.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.orai.io/developer-guides/oraichainevm/smart-contracts/wasm.md).

# Wasm

Oraichain not only provides Ethereum Virtual Machine but also has CosmWasm for developing dApps. With the Wasm precompiled contract, the EVM contract can now interact with the CosmWasm smart contract.

## Solidity Interfaces

The Wasm solidity interfaces include the following transactions:

* instantiate

Instantiate method allows caller to instantiate a wasm contract

```
function instantiate(
        uint64 codeID,
        string memory admin,
        bytes memory payload,
        string memory label,
        bytes memory coins
    ) external returns (string memory contractAddr, bytes memory data);
```

* execute

Execute method allows caller to execute a wasm contract

```
function execute(
        string memory contractAddress,
        bytes memory payload,
        bytes memory coins
    ) external returns (bytes memory response);
```

* query

Query method allows caller to query wasm smart contract state

```
function query(
        string memory contractAddress,
        bytes memory req
    ) external view returns (bytes memory response);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.orai.io/developer-guides/oraichainevm/smart-contracts/wasm.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
